#!/usr/bin/env python
#import roslib; roslib.load_manifest('drone_teleop')
import roslib; roslib.load_manifest('rygel')

#---setup MIN/MAX on drive (-1.0 to 1.0)
#---and PAN/TILT (-180, 180)
#---ADD PAN/TILT CONTROL LATER
#if val < .05 - set to 0.0
import rospy

from geometry_msgs.msg import Twist
from std_msgs.msg import Empty

import sys, select, termios, tty

msg = """
Reading from the keyboard  and Publishing to Twist!
---------------------------
up/down:       move forward/backward
left/right:    move left/right
w/s:           increase/decrease altitude - PAN/TILT LATER
a/d:           turn left/right
t/l:           takeoff/land ---REMOVE
r:             reset (toggle emergency state)
anything else: stop

please don't have caps lock on.
CTRL+c to quit
"""
lin_min = -1.0
lin_max = 1.0
ang_min = -1.0
ang_max = 1.0

lin_vel = 0.0
ang_vel = 0.0
pan_ang = 0
tilt_ang = 0

move_bindings = {
		65:('linear', 'x', 0.1),
		66:('linear', 'x', -0.1),
		67:('angular', 'z', 0.1),
		68:('angular', 'z', -0.1),
		#'w':('angular', 'x', 1),
		#'s':('angular', 'x', -1),
		#'a':('angular', 'y', 1),
		#'d':('angular', 'y', -1),
	       }

def getKey():
	tty.setraw(sys.stdin.fileno())
	select.select([sys.stdin], [], [], 0)
	key = sys.stdin.read(1)
	termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
	return key

if __name__=="__main__":
    	settings = termios.tcgetattr(sys.stdin)
	print msg
	
	pubDrive = rospy.Publisher('cmd_vel', Twist)
	pubPanTilt = rospy.Publisher('cmd_pantilt', Twist)

	rospy.init_node('rygel_KEYTELEOP')

	try:
		while(True):
			key = getKey()

                        if ord(key) == 27:
                            key = getKey()
                            key = getKey()
			drive_twist = Twist()
			if ord(key) in move_bindings.keys():
                                key = ord(key)
			if key in move_bindings.keys():
				#(lin_ang, xyz, speed) = move_bindings[key]
				(lin_ang, xyz, speed) = move_bindings[key]
				if lin_ang == 'linear':
					lin_vel += speed
					lin_vel = max(lin_vel, lin_min)
					lin_vel = min(lin_vel, lin_max)
					if lin_vel < .05 and lin_vel > 0.0: lin_vel = 0.0
					if lin_vel > -.05 and lin_vel < 0.0: lin_vel = 0.0
					#setattr(getattr(drive_twist, lin_ang), xyz, lin_vel)
				if lin_ang == 'angular':
					ang_vel += speed
					ang_vel = max(ang_vel, ang_min)
					ang_vel = min(ang_vel, ang_max)
					if ang_vel < .05 and ang_vel > 0.0: ang_vel = 0.0
					if ang_vel > -.05 and ang_vel < 0.0: ang_vel = 0.0
					#setattr(getattr(drive_twist, lin_ang), xyz, ang_vel)
				#setattr(getattr(drive_twist, lin_ang), xyz, lin_vel)
				#setattr(getattr(drive_twist, lin_ang), xyz, ang_vel)
				setattr(getattr(drive_twist, 'linear'), 'x', lin_vel)
				setattr(getattr(drive_twist, 'angular'), 'z', ang_vel)
	
			else:
				if (key == '\x03'):
					break

			pubDrive.publish(drive_twist)

	except Exception as e:
		print e
		print repr(e)

	finally:
		drive_twist = Twist()
		drive_twist.linear.x = 0; drive_twist.linear.y = 0; drive_twist.linear.z = 0
		drive_twist.angular.x = 0; drive_twist.angular.y = 0; drive_twist.angular.z = 0
		pubDrive.publish(drive_twist)

    		termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)


