#!/usr/bin/env python
import roslib; roslib.load_manifest('rygel')
import rospy
from rygel.msg import rygelIMURAW
from sensor_msgs.msg import Imu

def IMU_RAWlistener():
	rospy.init_node('IMU_RAWlistener', anonymous=True)
	rospy.Subscriber("IMU_RAW", rygelIMURAW, IMU_RAWcallback)
	rospy.spin()

def IMU_MSGsender():
	pubIMU = rospy.Publisher('IMU_MSG', Imu)
	rospy.init_node('IMU_MSGsender')

def IMU_RAWcallback(data):
	while not rospy.is_shutdown():
		IMUmsg = Imu()
		IMUmsg.header.frame_id = 0;
		IMUmsg.angular_velocity.x = data.gx
		IMUmsg.angular_velocity.y = data.gy
		IMUmsg.angular_velocity.z = data.gz
		IMUmsg.linear_acceleration.x = data.ax
		IMUmsg.linear_acceleration.y = data.ay
		IMUmsg.linear_acceleration.z = data.az
		pubIMU.publish(IMUmsg)

if __name__ == '__main__':	
	try:
		IMU_MSGsender()
	except rospy.ROSInterruptException:
		pass
	
	IMU_RAWlistener()


