#!/usr/bin/python
#----------------------------#
#---TEST RYGEL DEVICE FXNS---#
#----------------------------#
import serial
from time import sleep

#---SETUP SERIAL---#
print '|---BEGIN RYGEL DEVICE FXN TEST---|'
mySerial_device = '/dev/ttyUSB0'
#mySerial_device = '/dev/ttyUSB1'
#mySerial_baud = 115200
mySerial_baud = 9600
mySerial = serial.Serial(mySerial_device, mySerial_baud,
                         timeout=1)
#mySerial = serial.Serial(0)
mySerial.open()
if mySerial.isOpen():
    print mySerial
    print '|  -SERIAL SETUP COMPLETE'
else: print '|  -SERIAL SETUP FAILED'

#---TEST BOARD LED---#
print '|  -TESTING LED'
mySerial.write("LON\n")
sleep(.5)
mySerial.write("LOFF\n")   
sleep(.5)
mySerial.write("LON\n")
sleep(.5)
mySerial.write("LOFF\n")   

#---TEST PAN/TILT MOTORS---#
print '|  -PAN TEST'
mySerial.write("pan 110\n")
sleep(.5)
mySerial.write("pan 70\n")
sleep(.5)
mySerial.write("pan 90\n")
print '|  -TILT TEST'
mySerial.write("tilt 50\n")
sleep(2.5)
mySerial.write("tilt 75\n")
sleep(2.5)
mySerial.write("tilt 90\n")

#---TEST DRIVE MOTORS---#
print '|  -DRIVE MOTOR TEST'
mySerial.write("drive 1 85\n")
mySerial.write("drive 2 85\n")
mySerial.write("drive 3 85\n")
mySerial.write("drive 4 85\n")
sleep(1)
mySerial.write("drive 1 105\n")
mySerial.write("drive 2 105\n")
mySerial.write("drive 3 105\n")
mySerial.write("drive 4 105\n")
sleep(1)
mySerial.write("drive 1 90\n")
mySerial.write("drive 2 90\n")
mySerial.write("drive 3 90\n")
mySerial.write("drive 4 90\n")

#---TEST SONAR PING---#
print '|  -SONAR PING TEST'
mySerial.write("sping 0\n")
print mySerial.readline()
mySerial.write("sping 1\n")
print mySerial.readline()


#---TEST FIMU---###
print '|  -FIMU ACC/GYRO TEST'
mySerial.write("fimu\n")
print mySerial.readline()

#---TEST COMPLETE---#
mySerial.close()
print '---TEST COMPLETE---'

#######################################3

"""
import serial
ser = serial.Serial()
ser.port = "/dev/ttyUSB0" # may be called something different
ser.baudrate = 115200 # may be different
ser.open()
if ser.isOpen():
    ser.write("hello")
    response = ser.read(ser.inWaiting())

"""

"""
//------------------------------NOTES--------------------------------//

DRIVE MOTORS | 4=RB(-) | 3=LB(-) | 2=RF(-) | 1=LF
0-89 REVERSE / 91-180-FORWARD

LON     TURN BOARD LED ON
LOFF",    LED_off);       //-TURN BOARD LED OFF
pan | angle | delay
tile | angle
drive | motor (1-4) | speed (0-180)
sping | sonar# (0,1) | {returns cm}
fimu | {returns raw vals}



"""






