#!/usr/bin/env python
"""
http://drh-robotics-ros.googlecode.com/svn/trunk/ros/ardros/nodes/teleop.py
-This is made for holding the wiimote like old-school controller
-	with the d-pad on the left
"""
import roslib; roslib.load_manifest('rygel')
import rospy
from geometry_msgs.msg import Twist
from sensor_msgs.msg import Joy

#ADD AN ALL STOP COMMAND (A button)
#ADD PAN TILT - (d-pad)
#ALT SERVO (1,2)

#SUBSCRIBE TO WII/JOYSTICK, PULISH CMD_VEL
class WiimoteTeleop(object):
	panangle = 90
	tiltangle = 90
	altangle = 90
	def __init__(self, linearAxisIndex = 0, angularAxisIndex = 1):
		'''
		Initializes the receiver class. 
		port: The serial port to listen to.
		baudrate: Baud rate for the serial communication
:::NEED TO ADD GYRO CONTROL AND NUNCCHUCK TO CONTROL PAN/TILT?
		'''

		rospy.init_node('wii_teleop')

		self._LinearAxisIndex = rospy.get_param("~linearAxisIndex", linearAxisIndex)
		self._AngularAxisIndex = rospy.get_param("~angularAxisIndex", angularAxisIndex)
		#self._LinearScalingFactor = rospy.get_param("~linearScalingFactor", 0)
		#self._AngularScalingFactor = rospy.get_param("~angularScalingFactor", 0)

		rospy.loginfo("Starting wii-teleop node with linear axis %d and angular axis %d" % (self._LinearAxisIndex, self._AngularAxisIndex))

		# subscriptions
		rospy.Subscriber("joy", Joy, self._HandleJoystickMessage)
		self._VelocityCommandPublisher = rospy.Publisher("cmd_vel", Twist)
		self._PanTiltCommandPublisher = rospy.Publisher("cmd_pantilt", Twist)

	def _HandleJoystickMessage(self, joyMessage):
		#rospy.logwarn("Handling joystick message: " + str(joyMessage))

		velocityCommand = Twist()
		pantiltCommand = Twist()
		#velocityCommand.linear.x = self._LinearScalingFactor * joyMessage.axes[self._LinearAxisIndex]
		#velocityCommand.angular.z = self._AngularScalingFactor * joyMessage.axes[self._AngularAxisIndex]
		velocityCommand.linear.x = 0.1 * joyMessage.axes[self._LinearAxisIndex]
		velocityCommand.angular.z = 0.1 * joyMessage.axes[self._AngularAxisIndex]

		#ALT SERVO (NO PUBLISHER YET... ADD LATER)
		if joyMessage.buttons[0]: self.altangle -= 1
		if joyMessage.buttons[1]: self.altangle -= 1

		#PAN/TILT
		if joyMessage.buttons[8]: self.panangle -= 1
		if joyMessage.buttons[9]: self.panangle += 1
		if joyMessage.buttons[6]: self.tiltangle -= 1
		if joyMessage.buttons[7]: self.tiltangle += 1
		#---LIMIT TO -90, 90, etc.
		pantiltCommand.angular.z = self.panangle
		pantiltCommand.angular.y = self.tiltangle
		
		#ALL STOP (A BUTTON)
		if joyMessage.buttons[2]: 
			velocityCommand.linear.x = 0.0
			velocityCommand.angular.z = 0.0
		#STOP VELOCITY (TRIGGER) -FOR TANK TURNS... what;s the right term?
		if joyMessage.buttons[3]: 
			velocityCommand.linear.x = 0.0

		self._VelocityCommandPublisher.publish(velocityCommand)
		self._PanTiltCommandPublisher.publish(pantiltCommand)


if __name__ == '__main__':
	wii_teleop = WiimoteTeleop()
	rospy.spin()

