"""
|------------NOTES------------|
|-TERMINAL SIZE = 80x24
|-----------------------------|
"""
#---NEXT---#
#ALT refresh bottom line is weird...
#DRIVE MOTOR GUI - errors out if drive >180
#	something to do with row/column int too high




import curses
import serial
from time import sleep

myscreen = curses.initscr()
myscreen.keypad(1)
curses.noecho()

UDLRrow = 22	#---ROW/COL POS FOR UP|DOWN|LEFT|RIGHT
UDLRcol = 62

panPOS = 90	#---PAN/TILT POSITION VARS
panMIN = 0
panMAX = 180
panGUI_LENGTH = 13
tiltPOS = 90
tiltMIN = 20
tiltMAX = 160
tiltGUI_HEIGHT = 7
altPOS = 90
altMIN = 0
altMAX = 180
altGUI_LENGTH = 13

mlfPOS = 90	#---DRIVE MOTOR POSITION VARS
mrfPOS = 90
mlbPOS = 90
mrbPOS = 90
driveMIN = 0
driveMAX = 180
driveGUI_HEIGHT = 9

sonarAPOS = 0	#---SONAR PING VARS
sonarBPOS = 0
sonarMIN = 0	#---(FROM ARDUINO CODE)
sonarMAX = 200
sonarGUI_LENGTH = 50



#mySerial_device = '/dev/ttyUSB0'	#---SERIAL SETUP VARS
mySerial_device = '/dev/ttyUSB1'
mySerial_baud = 9600
#mySerial_baud = 115200
mySerialBOOL = False
	
def clamp(n, minn, maxn):
    if n <= minn:
        return minn
    elif n >= maxn:
        return maxn
    else:
        return n

def refreshScreen():
	myscreen.clear()
	myscreen.border(0)
	myscreen.addstr(0, 25, "|---DOMINAR RYGEL XVI---|")
	myscreen.addstr(1, 2, "(q)uit, (z)connect (x)disconnect (0,1) (p,o,k,m) (g) (j,l)")
	myscreen.refresh()		
	refreshDrive()
	refreshSonar()
	refreshSerial()
	refreshPanTilt()

def refreshPanTilt():
	#---ALT GUI
	altVAL = float(altPOS) / float(panMAX-altMIN)
	altINT = clamp(int(altVAL * altGUI_LENGTH), 0, altGUI_LENGTH-1)
	alt_win = curses.newwin(3, altGUI_LENGTH, 11, 45)
	alt_win.border(0)
	alt_win.addstr(1, altINT, "A")
	myscreen.addstr(11, 59, str(altPOS))
	myscreen.addstr(12, 59, str(altVAL)[0:3])
	myscreen.addstr(13, 59, str(altINT))
	alt_win.refresh()

	#---PAN GUI
	panVAL = float(panPOS) / float(panMAX-panMIN)
	panINT = clamp(int(panVAL * panGUI_LENGTH), 0, panGUI_LENGTH-1)
	pan_win = curses.newwin(3, panGUI_LENGTH, 8, 45)
	pan_win.border(0)
	pan_win.addstr(1, panINT, "P")
	myscreen.addstr(8,59, str(panPOS))
	myscreen.addstr(9,59, str(panVAL)[0:3])
	myscreen.addstr(10,59, str(panINT))
	pan_win.refresh()

	#---TILT GUI
	tiltVAL = float(tiltPOS) / float(tiltMAX-tiltMIN)
	tiltINT = clamp(int(tiltVAL * tiltGUI_HEIGHT)-tiltGUI_HEIGHT, 0, tiltGUI_HEIGHT-1)
	tiltINT = clamp(int(tiltVAL * tiltGUI_HEIGHT), 0, tiltGUI_HEIGHT-1)
	tilt_win = curses.newwin(tiltGUI_HEIGHT, 3, 2, 50)
	tilt_win.border(0)
	tilt_win.addstr(tiltGUI_HEIGHT - tiltINT, 1, "T")
	myscreen.addstr(2,58, str(tiltPOS))
	myscreen.addstr(3,58, str(tiltVAL)[0:3])
	myscreen.addstr(4,58, str(tiltINT))
	tilt_win.refresh()

def refreshDrive():	#---DRIVE MOTORS GUI	
	mlfVAL = float(mlfPOS) / float(driveMAX-driveMIN)
	mlfINT = int(mlfVAL * driveGUI_HEIGHT)
	mlf_win = curses.newwin(driveGUI_HEIGHT, 3, 2, 64)
	mlf_win.border(0)
	mlf_win.addstr(mlfINT, 1, "0")
	mlf_win.refresh()
	myscreen.addstr(11, 64, str(mlfPOS))

	mrfVAL = float(mrfPOS) / float(driveMAX-driveMIN)
	mrfINT = int(mrfVAL * driveGUI_HEIGHT)
	mrf_win = curses.newwin(driveGUI_HEIGHT, 3, 2, 70)
	mrf_win.border(0)
	mrf_win.addstr(mrfINT, 1, "0")
	mrf_win.refresh()
	myscreen.addstr(11, 70, str(mrfPOS))

	mlbVAL = float(mlbPOS) / float(driveMAX-driveMIN)
	mlbINT = int(mlbVAL * driveGUI_HEIGHT)
	mlb_win = curses.newwin(driveGUI_HEIGHT, 3, 12, 64)
	mlb_win.border(0)
	mlb_win.addstr(mlbINT, 1, "0")
	mlb_win.refresh()
	myscreen.addstr(21, 64, str(mlbPOS))

	mrbVAL = float(mrbPOS) / float(driveMAX-driveMIN)
	mrbINT = int(mrbVAL * driveGUI_HEIGHT)
	mrb_win = curses.newwin(driveGUI_HEIGHT, 3, 12, 70)
	mrb_win.border(0)
	mrb_win.addstr(mrbINT, 1, "0")
	mrb_win.refresh()
	myscreen.addstr(21, 70, str(mrbPOS))

def refreshSonar():	#---SONAR GUI
	sonarAVAL = float(sonarAPOS) / float(sonarMAX-sonarMIN)
	sonarAINT = clamp(int(sonarAVAL * sonarGUI_LENGTH), 0, sonarGUI_LENGTH-1)
	sonarA_win = curses.newwin(3, sonarGUI_LENGTH, 14, 8)
	sonarA_win.border(0)
	sonarA_win.addstr(1, sonarAINT, "X")
	myscreen.addstr(13, 8, "SONAR-A:")
	myscreen.addstr(13, 18, str(sonarAPOS).strip())
	sonarA_win.refresh()

	sonarBVAL = float(sonarBPOS) / float(sonarMAX-sonarMIN)
	sonarBINT = clamp(int(sonarBVAL * sonarGUI_LENGTH), 0, sonarGUI_LENGTH-1)
	sonarB_win = curses.newwin(3, sonarGUI_LENGTH, 18, 8)
	sonarB_win.border(0)
	sonarB_win.addstr(1, sonarBINT, "X")
	myscreen.addstr(17, 8, "SONAR-B:")
	myscreen.addstr(17, 18, str(sonarBPOS).strip())
	sonarB_win.refresh()

def refreshSerial():	#---SERIAL GUI
	serial_win = curses.newwin(5, 20, 2, 5)
	serial_win.border(0)
	if mySerialBOOL:
		serial_win.addstr(1, 1, "SERIAL CONNECTED", curses.A_BOLD)
		serial_win.addstr(2, 1, str(mySerial.port))
		serial_win.addstr(3, 1, str(mySerial.baudrate))
	else:
		serial_win.addstr(1, 1, "NO SERIAL")
	serial_win.refresh()

def movePan(thisPOS):
	if mySerialBOOL:
		panSTR = "pan " + str(thisPOS) + "\n"
		mySerial.write(panSTR)
	refreshPanTilt()

def moveTilt(thisPOS):
	if mySerialBOOL:
		thisSTR = "tilt " + str(thisPOS) + "\n"
		mySerial.write(thisSTR)
	refreshPanTilt()

def moveAlt(thisPOS):
	if mySerialBOOL:
		thisSTR = "alt " + str(thisPOS) + "\n"
		mySerial.write(thisSTR)
	refreshPanTilt()

def moveDrive(thisMOTOR, thisPOS):
	if mySerialBOOL:
		thisSTR = "drive " + str(thisMOTOR) + " " + str(thisPOS) + "\n"
		mySerial.write(thisSTR)
	refreshDrive()

def ping_sonar(thisSONAR):
	tempvar = 0
	if mySerialBOOL:
		pingSTR = "sping " + str(thisSONAR) + "\n"
		mySerial.write(pingSTR)
		tempvar = mySerial.readline()
	return tempvar


refreshScreen()


###---MAIN LOOP---###
while True: 
   event = myscreen.getch()

   if event == ord("q"):	#---QUIT
	curses.endwin()
	try: mySerial.close()
	except: pass
	break

   elif event == ord("z"):	#---SERIAL CONNECT
	mySerial = serial.Serial(mySerial_device, mySerial_baud, timeout=1)
	mySerial.open()
	if mySerial.isOpen():
		mySerialBOOL = True
	refreshSerial()	
   elif event == ord("x"):	#---SERIAL DISCONNECT
	try:
		mySerial.close()
		mySerialBOOL = False
		refreshSerial()
	except: pass

   elif event == ord("0"):	#---SONAR KEYS
	sonarAPOS = ping_sonar(0)
	sonarBPOS = ping_sonar(1)
	refreshSonar()
	
   elif event == ord("p"):	#---PAN KEYS
	panPOS += 1
	panPOS = clamp(panPOS, panMIN, panMAX)
	movePan(panPOS)	
   elif event == ord("o"):
	panPOS -= 1
	panPOS = clamp(panPOS, panMIN, panMAX)
	movePan(panPOS)
	
   elif event == ord("k"):	#---TILT KEYS
	tiltPOS += 1
	tiltPOS = clamp(tiltPOS, tiltMIN, tiltMAX)
	moveTilt(tiltPOS)
   elif event == ord("m"):
	tiltPOS -= 1
	tiltPOS = clamp(tiltPOS, tiltMIN, tiltMAX)
	moveTilt(tiltPOS)

   elif event == ord("j"):	#---ALT KEYS
	altPOS -= 1
	altPOS = clamp(altPOS, altMIN, altMAX)
	moveAlt(altPOS)
   elif event == ord("l"):
	altPOS += 1
	altPOS = clamp(altPOS, altMIN, altMAX)
	moveAlt(altPOS)

   elif event == curses.KEY_UP:	#---DRIVE KEYS
	myscreen.addstr(UDLRrow, UDLRcol, "| ALL FWD  |")
	mlfPOS -= 1
	mrfPOS -= 1
	mlbPOS -= 1
	mrbPOS -= 1
	mlfPOS = clamp(mlfPOS, driveMIN, driveMAX)
	mrfPOS = clamp(mrfPOS, driveMIN, driveMAX)
	mlbPOS = clamp(mlbPOS, driveMIN, driveMAX)
	mrbPOS = clamp(mrbPOS, driveMIN, driveMAX)
	moveDrive(1, mlfPOS)
	moveDrive(2, mrfPOS)
	moveDrive(3, mlbPOS)
	moveDrive(4, mrbPOS)
   elif event == curses.KEY_DOWN:
	myscreen.addstr(UDLRrow, UDLRcol, "| ALL REV  |")
	mlfPOS += 1
	mrfPOS += 1
	mlbPOS += 1
	mrbPOS += 1
	mlfPOS = clamp(mlfPOS, driveMIN, driveMAX)
	mrfPOS = clamp(mrfPOS, driveMIN, driveMAX)
	mlbPOS = clamp(mlbPOS, driveMIN, driveMAX)
	mrbPOS = clamp(mrbPOS, driveMIN, driveMAX)
	moveDrive(1, mlfPOS)
	moveDrive(2, mrfPOS)
	moveDrive(3, mlbPOS)
	moveDrive(4, mrbPOS)
   elif event == curses.KEY_LEFT:
	myscreen.addstr(UDLRrow, UDLRcol, "| TURN LEFT |")
	mlfPOS += 1
	mlbPOS += 1
	mlfPOS = clamp(mlfPOS, driveMIN, driveMAX)
	mlbPOS = clamp(mlbPOS, driveMIN, driveMAX)
	moveDrive(1, mlfPOS)
	moveDrive(3, mlbPOS)
   elif event == curses.KEY_RIGHT:
	myscreen.addstr(UDLRrow, UDLRcol, "| TURN RITE |")
	mrfPOS += 1
	mrbPOS += 1
	mrfPOS = clamp(mrfPOS, driveMIN, driveMAX)
	mrbPOS = clamp(mrbPOS, driveMIN, driveMAX)
	moveDrive(2, mrfPOS)
	moveDrive(4, mrbPOS)
   elif event == ord("g"):
	myscreen.addstr(UDLRrow, UDLRcol, "| ALL STOP  |")
	mlfPOS = 90
	mrfPOS = 90
	mlbPOS = 90
	mrbPOS = 90
	moveDrive(1, mlfPOS)
	moveDrive(2, mrfPOS)
	moveDrive(3, mlbPOS)
	moveDrive(4, mrbPOS)


