#ifndef ros_geometry_msgs_Point326D_h
#define ros_geometry_msgs_Point326D_h

#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include "../ros/msg.h"

namespace geometry_msgs
{

  class Point326D : public ros::Msg
  {
    public:
      float ax;
      float ay;
      float az;
      float gx;
      float gy;
      float gz;

    virtual int serialize(unsigned char *outbuffer)
    {
      int offset = 0;
      union {
        float real;
        unsigned long base;
      } u_ax;
      u_ax.real = this->ax;
      *(outbuffer + offset + 0) = (u_ax.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_ax.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_ax.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_ax.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->ax);
      union {
        float real;
        unsigned long base;
      } u_ay;
      u_ay.real = this->ay;
      *(outbuffer + offset + 0) = (u_ay.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_ay.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_ay.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_ay.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->ay);
      union {
        float real;
        unsigned long base;
      } u_az;
      u_az.real = this->az;
      *(outbuffer + offset + 0) = (u_az.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_az.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_az.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_az.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->az);

      union {
        float real;
        unsigned long base;
      } u_gx;
      u_gx.real = this->gx;
      *(outbuffer + offset + 0) = (u_gx.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gx.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_gx.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_gx.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->gx);
      union {
        float real;
        unsigned long base;
      } u_gy;
      u_gy.real = this->gy;
      *(outbuffer + offset + 0) = (u_gy.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gy.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_gy.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_gy.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->gy);
      union {
        float real;
        unsigned long base;
      } u_gz;
      u_gz.real = this->gz;
      *(outbuffer + offset + 0) = (u_gz.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gz.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_gz.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_gz.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->gz);


      return offset;
    }

    virtual int deserialize(unsigned char *inbuffer)
    {
      int offset = 0;
      union {
        float real;
        unsigned long base;
      } u_ax;
      u_ax.base = 0;
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->ax = u_ax.real;
      offset += sizeof(this->ax);
      union {
        float real;
        unsigned long base;
      } u_ay;
      u_ay.base = 0;
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->ay = u_ay.real;
      offset += sizeof(this->ay);
      union {
        float real;
        unsigned long base;
      } u_az;
      u_az.base = 0;
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->az = u_az.real;
      offset += sizeof(this->az);

      union {
        float real;
        unsigned long base;
      } u_gx;
      u_gx.base = 0;
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->gx = u_gx.real;
      offset += sizeof(this->gx);
      union {
        float real;
        unsigned long base;
      } u_gy;
      u_gy.base = 0;
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->gy = u_gy.real;
      offset += sizeof(this->gy);
      union {
        float real;
        unsigned long base;
      } u_gz;
      u_gz.base = 0;
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 2))) << (8 * 2);
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 3))) << (8 * 3);
      this->gz = u_gz.real;
      offset += sizeof(this->gz);

     return offset;
    }

    const char * getType(){ return "geometry_msgs/Point326D"; };

  };

}
#endif
