#ifndef ros_rygel_rygelIMURAW_h
#define ros_rygel_rygelIMURAW_h

#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include "../ros/msg.h"
#include "std_msgs/Header.h"

namespace rygel
{

  class rygelIMURAW : public ros::Msg
  {
    public:
      std_msgs::Header header;
      unsigned int gx;
      unsigned int gy;
      unsigned int gz;
      unsigned int ax;
      unsigned int ay;
      unsigned int az;

    virtual int serialize(unsigned char *outbuffer)
    {
      int offset = 0;
      offset += this->header.serialize(outbuffer + offset);
      union {
        unsigned int real;
        unsigned int base;
      } u_gx;
      u_gx.real = this->gx;
      *(outbuffer + offset + 0) = (u_gx.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gx.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->gx);
      union {
        unsigned int real;
        unsigned int base;
      } u_gy;
      u_gy.real = this->gy;
      *(outbuffer + offset + 0) = (u_gy.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gy.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->gy);
      union {
        unsigned int real;
        unsigned int base;
      } u_gz;
      u_gz.real = this->gz;
      *(outbuffer + offset + 0) = (u_gz.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_gz.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->gz);
      union {
        unsigned int real;
        unsigned int base;
      } u_ax;
      u_ax.real = this->ax;
      *(outbuffer + offset + 0) = (u_ax.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_ax.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->ax);
      union {
        unsigned int real;
        unsigned int base;
      } u_ay;
      u_ay.real = this->ay;
      *(outbuffer + offset + 0) = (u_ay.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_ay.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->ay);
      union {
        unsigned int real;
        unsigned int base;
      } u_az;
      u_az.real = this->az;
      *(outbuffer + offset + 0) = (u_az.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_az.base >> (8 * 1)) & 0xFF;
      offset += sizeof(this->az);
      return offset;
    }

    virtual int deserialize(unsigned char *inbuffer)
    {
      int offset = 0;
      offset += this->header.deserialize(inbuffer + offset);
      union {
        unsigned int real;
        unsigned int base;
      } u_gx;
      u_gx.base = 0;
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gx.base |= ((typeof(u_gx.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->gx = u_gx.real;
      offset += sizeof(this->gx);
      union {
        unsigned int real;
        unsigned int base;
      } u_gy;
      u_gy.base = 0;
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gy.base |= ((typeof(u_gy.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->gy = u_gy.real;
      offset += sizeof(this->gy);
      union {
        unsigned int real;
        unsigned int base;
      } u_gz;
      u_gz.base = 0;
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_gz.base |= ((typeof(u_gz.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->gz = u_gz.real;
      offset += sizeof(this->gz);
      union {
        unsigned int real;
        unsigned int base;
      } u_ax;
      u_ax.base = 0;
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_ax.base |= ((typeof(u_ax.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->ax = u_ax.real;
      offset += sizeof(this->ax);
      union {
        unsigned int real;
        unsigned int base;
      } u_ay;
      u_ay.base = 0;
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_ay.base |= ((typeof(u_ay.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->ay = u_ay.real;
      offset += sizeof(this->ay);
      union {
        unsigned int real;
        unsigned int base;
      } u_az;
      u_az.base = 0;
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 0))) << (8 * 0);
      u_az.base |= ((typeof(u_az.base)) (*(inbuffer + offset + 1))) << (8 * 1);
      this->az = u_az.real;
      offset += sizeof(this->az);
     return offset;
    }

    const char * getType(){ return "rygel/rygelIMURAW"; };

  };

}
#endif