//-------------------------------------------------------------------//
//------------------------------NEXT---------------------------------//
//-------------------------------------------------------------------//
//-FIX TILT, IT'S FUBAR!!!
//-SPEEDS AND MAX ANGLES ARE SET REALLY LOW FOR RIGH NOW...
//-QUADRATIC ACCELERATION FOR SERVOS?
//-BETTER GYRO/ACC REPORTING... INTERRUPTS?
//-SOFTWARE PWM & FASTSPI?
//-SOFTWARE SERIAL & BLUETOOTH TX/RX?
//-ABSTRACT OUT DRIVE FUNCTIONS BETTER
//    SLOW ACCELERATION, ETC...
//------------------------------NOTES--------------------------------//
//-SONAR = HC-SR04
//-GYRO = MPU6050 | GY-521
//-PAN/TILT SERVOS | 9gram angle (0-180?ish)
//-MOTOR SERVOS | Xgram continuous rotation (0-180?ish)
//-DRIVE MOTORS | 4=RB(-) | 3=LB(-) | 2=RF(-) | 1=LF | 0-89 REVERSE / 91-180-FORWARD
//-------------------------------------------------------------------//
#include <SerialCommand.h>  //-FOR SERIAL INTERFACE
#include <Servo.h>          //-FOR SERVO MOTORS
#include <NewPing.h>        //-FOR SONAR RANGEFINDER
#include <I2Cdev.h>         //-FOR FREEIMU
#include <MPU60X0.h>        //-FOR FREEIMU
#include <EEPROM.h>         //-FOR FREEIMU
#include "DebugUtils.h"     //-FOR FREEIMU
#include "FreeIMU.h"        //-FOR FREEIMU
#include <Wire.h>           //-FOR FREEIMU
#include <SPI.h>            //-FOR FREEIMU

#define SERIAL_SPEED   9600
//#define SERIAL_SPEED   115200
#define arduinoLED     13  //---ONBOARD LED
#define TRIGGER_PIN_0  14  //---SONAR 0 TRIGGER
#define ECHO_PIN_0     15  //---SONAR 0 ECHO
#define TRIGGER_PIN_1  16  //---SONAR 1 TRIGGER
#define ECHO_PIN_1     17  //---SONAR 1 ECHO
#define MAX_DISTANCE   200 //---SONAR MAX DISTANCE
#define pinPANmotor    10  //---PAN MOTOR PIN
#define pinTILTmotor   11  //---TILT MOTOR PIN
#define pinLFmotor     3   //---LEFT FRONT MOTOR PIN
#define pinRFmotor     5   //---RIGHT FRONT MOTOR PIN
#define pinLBmotor     6   //---LEFT BACK MOTOR PIN
#define pinRBmotor     9   //---RIGHT BACK MOTOR PIN

//---SERVO MIN/MAX VARS
int posPANmin = 60; int posPANmax = 120;
int posTILTmin = 80; int posTILTmax = 120;
int posMOTORmin = 60; int posMOTORmax = 120;
//---SERVO POSITION VARS
int posPANmotor = posPANmin + ((posPANmax - posPANmin) / 2);     //---DEFAULT PAN
int posTILTmotor = posTILTmin + ((posTILTmax - posTILTmin) / 2); //---DEFAULT TILT
int posLFmotor = posMOTORmin + ((posMOTORmax - posMOTORmin) / 2);                //---LEFT FRONT
int posRFmotor = posMOTORmin + ((posMOTORmax - posMOTORmin) / 2);                //---RIGHT FRONT
int posRBmotor = posMOTORmin + ((posMOTORmax - posMOTORmin) / 2);                //---LEFT BACK
int posLBmotor = posMOTORmin + ((posMOTORmax - posMOTORmin) / 2);                //---RIGHT BACK
//---GYRO/ACC FREEIMU VARS
int FIMU_raw[11];
char FIMU_str[512];
float FIMU_val[9];

//---SERVO MOTOR OBJECTS
Servo objPANmotor;
Servo objTILTmotor;
Servo objLFmotor;
Servo objRFmotor;
Servo objLBmotor;
Servo objRBmotor;
//---SONAR PING OBJECTS
NewPing sonar0(TRIGGER_PIN_0, ECHO_PIN_0, MAX_DISTANCE);
NewPing sonar1(TRIGGER_PIN_1, ECHO_PIN_1, MAX_DISTANCE);
//---GYRO/ACC FREEIMU OBJECTS
FreeIMU my3IMU = FreeIMU();
//--SERIAL COMMAND OBJECT
SerialCommand sCmd;

//--------------------------//
//---SETUP/LOOP FUNCTIONS---//
//--------------------------//
void setup() {
  pinMode(arduinoLED, OUTPUT);    //-SETUP ONBOARD LED
  digitalWrite(arduinoLED, LOW);  //-SET ONBOARD LED OFF

  objPANmotor.attach(pinPANmotor);  //-ATTACH SERVO MOTOR OBJECTS
  objTILTmotor.attach(pinTILTmotor);
  objLFmotor.attach(pinLFmotor);
  objRFmotor.attach(pinRFmotor);
  objLBmotor.attach(pinLBmotor);
  objRBmotor.attach(pinRBmotor);

  Wire.begin();    //-START FREE-IMU MONITOR  
  delay(500);
  my3IMU.init(true); //-ENABLE/DISABLE FASTMODE
  delay(500);

  Serial.begin(SERIAL_SPEED);
  //---SETUP CALLBACKS FOR SerialCommand
  sCmd.addCommand("LON",    LED_on);         //-TURN BOARD LED ON
  sCmd.addCommand("LOFF",    LED_off);       //-TURN BOARD LED OFF
  sCmd.addCommand("pan",   PANmotor_sweep);    //-pan | angle | delay
  sCmd.addCommand("tilt",   TILTmotor_sweep);  //-tile | angle
  sCmd.addCommand("drive",  DRIVEmotor);       //-drive | motor (0-3|LF,RF,LB,RB) | angle/speed
  sCmd.addCommand("sping", SONARping);         //-sping | sonar# (0,1) {returns cm}
  sCmd.addCommand("fimu", get_FIMUraw);        //-fimu | {returns raw vals}
  sCmd.addCommand("fimuX", get_FIMUselect);    //-fimuX | {returns select vals}
  sCmd.setDefaultHandler(unrecognized);        //-HANDLER FOR UNKNOWN COMMANDS
  //Serial.println("|RYGEL| - LET'S GET IT ON!!!");
}

void loop() {
  sCmd.readSerial();  //---PROCESS SERIAL COMMANDS
}

//-----------------------//
//---UTILITY FUNCTIONS---//
//-----------------------//

//---GYRO / ACC - RETURNS FREEIMU RAW VALUES
void get_FIMUraw() {
  my3IMU.getRawValues(FIMU_raw);
  #if HAS_MS5611() 
    //-WITH BAROMETER
    sprintf(FIMU_str, "%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d", FIMU_raw[0], FIMU_raw[1], FIMU_raw[2], FIMU_raw[3], FIMU_raw[4], FIMU_raw[5], FIMU_raw[6], FIMU_raw[7], FIMU_raw[8], FIMU_raw[9], FIMU_raw[10]);
  #else  
    //-WITHOUT BAROMTER
    sprintf(FIMU_str, "%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t", FIMU_raw[0], FIMU_raw[1], FIMU_raw[2], FIMU_raw[3], FIMU_raw[4], FIMU_raw[5], FIMU_raw[6], FIMU_raw[7], FIMU_raw[8]);
  #endif
  Serial.print(FIMU_str);
}

//---SELECT VALUE TO BE RETURNED (0-8)
void get_FIMUselect(int rVAL) {
  int aNumber; char *arg;
  unsigned int uS = 999;
  arg = sCmd.next();
  if (arg != NULL) {
  	my3IMU.getRawValues(FIMU_raw);
  	Serial.print(FIMU_raw[rVAL]);
}


//---CHECK IF POSITIVE OR NEGATIVE - RETURNS -1/1 if <1/>1
int negpos(int invar){
  int outvar;
  if (invar >= 0){outvar = 1;}
  else if (invar < 0){outvar = -1;}
  return outvar;  
}

//---ULTRASONIC PING - RETURNS DISTANCE IN CENTIMETERS
void SONARping() {
  int aNumber; char *arg;
  unsigned int uS = 999;
  arg = sCmd.next();
  if (arg != NULL) {
    aNumber = atoi(arg);
    if (aNumber == 0) {uS = sonar0.ping();} //---SONAR 0
    if (aNumber == 1) {uS = sonar1.ping();} //---SONAR 1
  Serial.print(uS / US_ROUNDTRIP_CM);
  }
}

//---SET CONTINUOUS ROTATION SERVO MOTOR SPEED - motor# | angle
void DRIVEmotor() {
  int aMotor; int aAngle;
  char *arg;
  arg = sCmd.next(); //-SERVO NUMBER | 1=LF, 2=RF, 3=LB, 4=RB
  if (arg != NULL){aMotor = atoi(arg);}  
  arg = sCmd.next(); //-ANGLE TO SET (+/-ANGLE = SPEED)
  if (arg != NULL){aAngle = min(max(atoi(arg),posPANmin),posPANmax);}
  if (aMotor != NULL && aAngle != NULL) {
    if (aMotor == 1){objLFmotor.write(aAngle);}
    if (aMotor == 2){objRFmotor.write(aAngle);}
    if (aMotor == 3){objLBmotor.write(aAngle);}
    if (aMotor == 4){objRBmotor.write(aAngle);}
  }
}

//---SWEEPS DRIVE MOTOR TO SET SPEED
void DRIVEmotor_sweep() {
  int tempDelay = 10;
  int aNewAngle; //int aDelay;
  char *arg;
  arg = sCmd.next(); //-SERVO NUMBER | 0=LF, 1=RF, 2=LB, 3=RB
  if (arg != NULL){
    aNewAngle = min(max(atoi(arg),posPANmin),posPANmax);
    int angleDifference = aNewAngle - posPANmotor;
    int np = negpos(angleDifference);
    if (np > 0){
        for(int ang = posPANmotor; ang <= aNewAngle; ang++){        
        objPANmotor.write(ang);
        delay(tempDelay);
      }
    }
    if (np < 0){
        for(int ang = posPANmotor; ang >= aNewAngle; ang--){        
        objPANmotor.write(ang);
        delay(tempDelay);
      }
    }
    posPANmotor = aNewAngle;
  }
}


//---SWEEPS PAN MOTOR, CHECKS MIN/MAX VALUES - newangle
//---later maybe do a quadratic acceleration to new angle?
void PANmotor_sweep() {
  int tempDelay = 10;
  int aNewAngle;
  char *arg;
  arg = sCmd.next(); //-SERVO NUMBER | 0=LF, 1=RF, 2=LB, 3=RB
  if (arg != NULL){
    aNewAngle = min(max(atoi(arg),posPANmin),posPANmax);
    int angleDifference = aNewAngle - posPANmotor;
    int np = negpos(angleDifference);
    if (np > 0){
        for(int ang = posPANmotor; ang <= aNewAngle; ang++){        
        objPANmotor.write(ang);
        delay(tempDelay);
      }
    }
    if (np < 0){
        for(int ang = posPANmotor; ang >= aNewAngle; ang--){        
        objPANmotor.write(ang);
        delay(tempDelay);
      }
    }
    posPANmotor = aNewAngle;
  }
}

//---SWEEPS TILT MOTOR, CHECKS MIN/MAX VALUES - newangle | delay
void TILTmotor_sweep() {
  int tempDelay = 10;
  int aNewAngle;
  char *arg;
  arg = sCmd.next(); //-SERVO NUMBER | 0=LF, 1=RF, 2=LB, 3=RB
  if (arg != NULL){
    aNewAngle = min(max(atoi(arg),posTILTmin),posTILTmax);
    int angleDifference = aNewAngle - posTILTmotor;
    int np = negpos(angleDifference);
    if (np > 0){
        for(int ang = posTILTmotor; ang <= aNewAngle; ang++){        
        objTILTmotor.write(ang);
        delay(tempDelay);
      }
    }
    if (np < 0){
        for(int ang = posTILTmotor; ang >= aNewAngle; ang--){        
        objTILTmotor.write(ang);
        delay(tempDelay);
      }
    }
    posTILTmotor = aNewAngle;
  }
}

void LED_on() {
  digitalWrite(arduinoLED, HIGH);
}

void LED_off() {
  digitalWrite(arduinoLED, LOW);
}

//---HANDLES UNKNOWN SerialCommands
void unrecognized(const char *command) {
  Serial.println(":::DO WHAT NOW??");
}


